using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace GGC_QueryCellFormattedText
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable mt = new DataTable("MyTable");
            mt.Columns.Add("StudentID", typeof(int));
            mt.Columns.Add("StudentName", typeof(string));
            mt.Columns.Add("Total Marks", typeof(string));

            mt.Rows.Add(new Object[] { 101, "Martin", 78 });
            mt.Rows.Add(new Object[] { 105, "Priya", 31 });
            mt.Rows.Add(new Object[] { 102, "Wincy", 45 });
            mt.Rows.Add(new Object[] { 104, "Sam", 61 });
            mt.Rows.Add(new Object[] { 103, "Peter", 99 });

            this.gridGroupingControl1.DataSource = mt;
           
            this.gridGroupingControl1.TableControlDrawCellDisplayText += new GridTableControlDrawCellDisplayTextEventHandler(gridGroupingControl1_TableControlDrawCellDisplayText);
            this.gridGroupingControl1.TableControlCurrentCellChanging += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellChanging);
            this.gridGroupingControl1.TableControlCurrentCellValidating += new GridTableControlCancelEventHandler(gridGroupingControl1_TableControlCurrentCellValidating);
           
        }

        void gridGroupingControl1_TableControlCurrentCellValidating(object sender, GridTableControlCancelEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            if (cc.Renderer.ControlText.IndexOf("[inch]") == -1)
            {
                e.Inner.Cancel = true;
                cc.Renderer.ControlText = string.Empty; 
                MessageBox.Show("Invalid Entry");

            }
            else
                cc.Renderer.ControlText = cc.Renderer.ControlText.Replace("[inch]", "");
        }

        private object OldCellValue = string.Empty;

        void gridGroupingControl1_TableControlCurrentCellChanging(object sender, GridTableControlCancelEventArgs e)
        {
            GridCurrentCell cc = e.TableControl.CurrentCell;
            e.TableControl.Model[cc.RowIndex, cc.ColIndex].CellValue = string.Empty;  
        }

        void gridGroupingControl1_TableControlDrawCellDisplayText(object sender, GridTableControlDrawCellDisplayTextEventArgs e)
        {
            if (e.Inner.ColIndex == 3
                && e.Inner.RowIndex > 0 )
            {
                e.Inner.DisplayText = String.Format("{0}[inch]", e.Inner.Style.CellValue);
            }
        }
       
    }
}